using System;
using System.Diagnostics;
using System.Runtime.InteropServices;
using EtherealEngine.Models;

namespace EtherealEngine.Services;

public class AntiDebug
{
	private static long CONTEXT_DEBUG_REGISTERS = 65552L;

	[DllImport("kernel32.dll", SetLastError = true)]
	private static extern bool CloseHandle(IntPtr Handle);

	[DllImport("kernel32.dll", SetLastError = true)]
	private static extern bool IsDebuggerPresent();

	[DllImport("kernel32.dll", SetLastError = true)]
	private static extern bool CheckRemoteDebuggerPresent(IntPtr Handle, ref bool CheckBool);

	[DllImport("kernel32.dll", SetLastError = true)]
	private static extern IntPtr GetModuleHandle(string lib);

	[DllImport("kernel32.dll", SetLastError = true)]
	private static extern IntPtr GetProcAddress(IntPtr ModuleHandle, string Function);

	[DllImport("kernel32.dll", SetLastError = true)]
	private static extern bool WriteProcessMemory(IntPtr ProcHandle, IntPtr BaseAddress, byte[] Buffer, uint size, int NumOfBytes);

	[DllImport("ntdll.dll", SetLastError = true)]
	private static extern uint NtSetInformationThread(IntPtr ThreadHandle, uint ThreadInformationClass, IntPtr ThreadInformation, int ThreadInformationLength);

	[DllImport("kernel32.dll", SetLastError = true)]
	private static extern IntPtr OpenThread(uint DesiredAccess, bool InheritHandle, int ThreadId);

	[DllImport("kernel32.dll", SetLastError = true)]
	private static extern uint GetTickCount();

	[DllImport("kernel32.dll", SetLastError = true)]
	private static extern void OutputDebugStringA(string Text);

	[DllImport("kernel32.dll", SetLastError = true)]
	private static extern uint GetLastError();

	[DllImport("kernel32.dll", SetLastError = true)]
	private static extern IntPtr GetCurrentThread();

	[DllImport("kernel32.dll", SetLastError = true)]
	private static extern bool GetThreadContext(IntPtr hThread, ref Structs.CONTEXT Context);

	[DllImport("ntdll.dll", SetLastError = true)]
	private static extern uint NtQueryInformationProcess(IntPtr hProcess, uint ProcessInfoClass, out uint ProcessInfo, uint nSize, uint ReturnLength);

	[DllImport("ntdll.dll", SetLastError = true)]
	private static extern uint NtQueryInformationProcess(IntPtr hProcess, uint ProcessInfoClass, out IntPtr ProcessInfo, uint nSize, uint ReturnLength);

	public static bool CloseHandleAntiDebug()
	{
		try
		{
			CloseHandle((IntPtr)19075618L);
			return false;
		}
		catch (Exception ex)
		{
			if (ex.Message == "External component has thrown an exception.")
			{
				return true;
			}
		}
		return false;
	}

	public static bool DebuggerIsAttached()
	{
		return Debugger.IsAttached;
	}

	public static bool IsDebuggerPresentCheck()
	{
		if (IsDebuggerPresent())
		{
			return true;
		}
		return false;
	}

	public static bool NtQueryInformationProcessCheck_ProcessDebugFlags()
	{
		uint ProcessInfo = 0u;
		NtQueryInformationProcess(Process.GetCurrentProcess().Handle, 31u, out ProcessInfo, 4u, 0u);
		if (ProcessInfo == 0)
		{
			return true;
		}
		return false;
	}

	public static bool NtQueryInformationProcessCheck_ProcessDebugPort()
	{
		uint ProcessInfo = 0u;
		NtQueryInformationProcess(Process.GetCurrentProcess().Handle, 7u, out ProcessInfo, 4u, 0u);
		if (ProcessInfo != 0)
		{
			return true;
		}
		return false;
	}

	public static bool NtQueryInformationProcessCheck_ProcessDebugObjectHandle()
	{
		IntPtr ProcessInfo = IntPtr.Zero;
		NtQueryInformationProcess(Process.GetCurrentProcess().Handle, 30u, out ProcessInfo, 4u, 0u);
		if (ProcessInfo != IntPtr.Zero)
		{
			return true;
		}
		return false;
	}

	public static string PatchingDbgUiRemoteBreakin()
	{
		IntPtr procAddress = GetProcAddress(GetModuleHandle("ntdll.dll"), "DbgUiRemoteBreakin");
		byte[] buffer = new byte[1] { 204 };
		if (WriteProcessMemory(Process.GetCurrentProcess().Handle, procAddress, buffer, 1u, 0))
		{
			return "Success";
		}
		return "Failed";
	}

	public static bool FindWindowAntiDebug()
	{
		Process[] processes = Process.GetProcesses();
		foreach (Process process in processes)
		{
			string[] array = new string[3] { "x32dbg", "x64dbg", "ollydbg" };
			foreach (string value in array)
			{
				if (process.MainWindowTitle.ToLower().Contains(value))
				{
					return true;
				}
			}
		}
		return false;
	}

	public static string HideThreadsAntiDebug()
	{
		foreach (ProcessThread thread in Process.GetCurrentProcess().Threads)
		{
			IntPtr intPtr = OpenThread(32u, InheritHandle: false, thread.Id);
			if (intPtr != IntPtr.Zero)
			{
				uint num = NtSetInformationThread(intPtr, 17u, IntPtr.Zero, 0);
				CloseHandle(intPtr);
				if (num == 0)
				{
					return "Success";
				}
			}
		}
		return "Failed";
	}

	public static bool GetTickCountAntiDebug()
	{
		uint tickCount = GetTickCount();
		_ = Process.GetCurrentProcess().MainModule!.FileName;
		Process.GetCurrentProcess().PrivateMemorySize64.ToString();
		return GetTickCount() - tickCount > 2;
	}

	public static bool OutputDebugStringAntiDebug()
	{
		OutputDebugStringA("just testing some stuff...");
		if (Marshal.GetLastWin32Error() == 0)
		{
			return true;
		}
		return false;
	}

	public static void OllyDbgFormatStringExploit()
	{
		OutputDebugStringA("%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s");
	}

	public static bool DebugBreakAntiDebug()
	{
		try
		{
			Debugger.Break();
			return false;
		}
		catch
		{
			return true;
		}
	}

	public static bool HardwareRegistersBreakpointsDetection()
	{
		Structs.CONTEXT Context = default(Structs.CONTEXT);
		Context.ContextFlags = CONTEXT_DEBUG_REGISTERS;
		if (GetThreadContext(GetCurrentThread(), ref Context) && (Context.Dr1 != 0 || Context.Dr2 != 0 || Context.Dr3 != 0 || Context.Dr4 != 0 || Context.Dr5 != 0 || Context.Dr6 != 0 || Context.Dr7 != 0))
		{
			return true;
		}
		return false;
	}
}
