using System;
using System.IO;
using System.Net.Http;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using EtherealEngine.Models;
using Newtonsoft.Json;

namespace EtherealEngine.Services;

public class Api
{
	public static string tempPath;

	private readonly Configuration config = new Configuration();

	public async Task<string> GetDllBytes()
	{
		try
		{
			StringContent content = new StringContent(JsonConvert.SerializeObject(new
			{
				password = Xor.EncryptOrDecrypt("EtherealKey420"),
				username = Settings.Default.username
			}).ToString(), Encoding.UTF8, "application/json");
			using HttpClient client = new HttpClient();
			DllApiReplyModel dllApiReplyModel = JsonConvert.DeserializeObject<DllApiReplyModel>((await client.PostAsync(config.dllApiUrl, content)).Content.ReadAsStringAsync().Result);
			if (!string.IsNullOrEmpty(dllApiReplyModel.content))
			{
				string s = Xor.EncryptOrDecrypt(dllApiReplyModel.content, dll: true);
				Encoding.ASCII.GetBytes(s);
				byte[] bytes = Convert.FromBase64String(s);
				if (tempPath == null)
				{
					tempPath = Path.GetTempFileName().Replace(".tmp", ".dmp");
				}
				File.WriteAllBytes(tempPath, bytes);
				return tempPath;
			}
			MessageBox.Show("Error getting data from API.");
			DeleteFile();
			Application.Current.Shutdown();
		}
		catch (Exception)
		{
			DeleteFile();
			MessageBox.Show("Error connecting to api.");
			Application.Current.Shutdown();
		}
		return null;
	}

	public static async void DeleteFile()
	{
		try
		{
			for (int i = 0; i < 2; i++)
			{
				if (File.Exists(tempPath))
				{
					await File.WriteAllTextAsync(tempPath, "");
					File.Delete(tempPath);
					Directory.Delete(tempPath, recursive: true);
					if (File.Exists(tempPath.Replace(".dmp", ".tmp")))
					{
						File.Delete(tempPath.Replace(".dmp", ".tmp"));
						Directory.Delete(tempPath.Replace(".dmp", ".tmp"), recursive: true);
					}
				}
				if (Directory.Exists("C:\\Ethereal.zip"))
				{
					Directory.Delete("C:\\Ethereal.zip", recursive: true);
				}
			}
		}
		catch (Exception)
		{
		}
	}

	public static async Task<MainApiReply> CheckMainApi()
	{
		Configuration configuration = new Configuration();
		MainApiReply res = null;
		try
		{
			using (HttpClient client = new HttpClient())
			{
				MainApiReply mainApiReply = JsonConvert.DeserializeObject<MainApiReply>((await client.GetAsync(configuration.CanIRunApiUrl)).Content.ReadAsStringAsync().Result);
				if (mainApiReply != null)
				{
					res = mainApiReply;
				}
			}
			return res;
		}
		catch (Exception)
		{
			MessageBox.Show("Error connecting to api.");
			Application.Current.Shutdown();
			return res;
		}
	}

	public static async Task<OnlineUsersApiReply> CountUserApi(bool UserOnline = false)
	{
		Configuration configuration = new Configuration();
		OnlineUsersApiReply res = null;
		try
		{
			StringContent content = new StringContent(JsonConvert.SerializeObject(new
			{
				username = Settings.Default.username,
				userOnline = UserOnline
			}).ToString(), Encoding.UTF8, "application/json");
			using (HttpClient client = new HttpClient())
			{
				OnlineUsersApiReply onlineUsersApiReply = JsonConvert.DeserializeObject<OnlineUsersApiReply>((await client.PostAsync(configuration.OnlineCountApiUrl, content)).Content.ReadAsStringAsync().Result);
				if (onlineUsersApiReply != null)
				{
					res = onlineUsersApiReply;
				}
			}
			return res;
		}
		catch (Exception ex)
		{
			Console.WriteLine(ex.Message);
			return res;
		}
	}
}
