using System;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Windows;
using Microsoft.Win32;

namespace EtherealEngine.Services;

internal class AutoUpdater
{
	public static void AutoUpdate(string newVersion)
	{
		try
		{
			string text = Path.Combine(Directory.GetCurrentDirectory(), "Updater.exe");
			if (File.Exists(text))
			{
				Process.Start(text);
			}
			Application.Current.Shutdown();
		}
		catch (Exception ex)
		{
			Console.WriteLine(ex.Message);
		}
	}

	private static bool IsSoftwareInstalled(string softwareName)
	{
		string softwareName2 = softwareName;
		RegistryKey key = Registry.LocalMachine.OpenSubKey("SOFTWARE\\Wow6432Node\\Microsoft\\Windows\\CurrentVersion\\Uninstall");
		if (key != null && (from keyName in key.GetSubKeyNames()
			select key.OpenSubKey(keyName) into subkey
			select subkey?.GetValue("DisplayName") as string).Any((string displayName) => displayName?.Contains(softwareName2) ?? false))
		{
			return true;
		}
		key = Registry.LocalMachine.OpenSubKey("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall");
		if (key != null && (from keyName in key.GetSubKeyNames()
			select key.OpenSubKey(keyName) into subkey
			select subkey?.GetValue("DisplayName") as string).Any((string displayName) => displayName?.Contains(softwareName2) ?? false))
		{
			return true;
		}
		return false;
	}
}
