using System;
using System.Net.NetworkInformation;
using System.Threading.Tasks;

namespace EtherealEngine.Services;

public class Network
{
	public static async Task<bool> IsOnline()
	{
		return await PingWeb("google.com");
	}

	private static async Task<bool> PingWeb(string url)
	{
		IPStatus iPStatus;
		try
		{
			iPStatus = (await new Ping().SendPingAsync(url, 2000)).Status;
		}
		catch (Exception)
		{
			iPStatus = IPStatus.TimedOut;
		}
		return iPStatus == IPStatus.Success;
	}
}
