using System;
using DiscordRPC;

namespace EtherealEngine.Services;

public static class RichPresenceAPI
{
	private static readonly DiscordRpcClient Client;

	public static readonly RichPresence Presence;

	static RichPresenceAPI()
	{
		Client = new DiscordRpcClient("1003757727794855987");
		Presence = new RichPresence
		{
			Details = "",
			State = "",
			Assets = new Assets
			{
				LargeImageKey = "https://imgur.com/gmZN1yI.gif",
				LargeImageText = "Ethereal " + Settings.Default.menuversion
			},
			Buttons = new Button[1]
			{
				new Button
				{
					Label = "Visit Website",
					Url = "https://etherealmenu.cn/"
				}
			}
		};
	}

	public static void Initialize()
	{
		try
		{
			Client.Initialize();
			Update();
		}
		catch (Exception ex)
		{
			throw new Exception(ex.Message);
		}
	}

	public static void Update(bool setTIme = true)
	{
		try
		{
			if (Client.IsInitialized)
			{
				if (setTIme)
				{
					Presence.Timestamps = Timestamps.Now;
				}
				Client.SetPresence(Presence);
			}
			else
			{
				Client.Initialize();
				Presence.Timestamps = Timestamps.Now;
				Client.SetPresence(Presence);
			}
		}
		catch (Exception ex)
		{
			throw new Exception(ex.Message);
		}
	}

	public static void Disable()
	{
		try
		{
			if (Client.IsInitialized)
			{
				Client.ClearPresence();
				return;
			}
			Client.Initialize();
			Client.ClearPresence();
		}
		catch (Exception ex)
		{
			throw new Exception(ex.Message);
		}
	}
}
