using System;
using System.CodeDom.Compiler;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Management;
using System.Reflection;
using System.Runtime.CompilerServices;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Markup;
using System.Windows.Media;
using System.Windows.Threading;
using EtherealEngine.Models;
using EtherealEngine.Services;
using Hardcodet.Wpf.TaskbarNotification;
using MaterialDesignThemes.Wpf;

namespace EtherealEngine;

public class LoginWIndow : Window, IComponentConnector
{
	private readonly DispatcherTimer clock = new DispatcherTimer();

	private DateTime logginInIn;

	private bool autologgingIn;

	private bool isloggedin;

	private Configuration config = new Configuration();

	internal Border DragOnHold;

	internal PackIcon CloseAppButton;

	internal TextBlock LaunsherVersion;

	internal TextBox usernameb;

	internal PasswordBox passwordb;

	internal Button SigninBTN;

	internal Button RegisterBTN;

	internal TextBlock loginTimer;

	private bool _contentLoaded;

	public LoginWIndow()
	{
		InitializeComponent();
		clock.Tick += Timer;
		clock.Interval = new TimeSpan(0, 0, 1);
		SigninBTN.MouseEnter += Button_MouseHover;
		SigninBTN.MouseLeave += Button_MouseLeave;
		RegisterBTN.MouseEnter += Button_MouseHover1;
		RegisterBTN.MouseLeave += Button_MouseLeave1;
		if (Process.GetProcessesByName(Path.GetFileNameWithoutExtension(Assembly.GetEntryAssembly()?.Location)).Count() > 1)
		{
			TaskbarIcon taskbarIcon = new TaskbarIcon();
			taskbarIcon.Icon = System.Drawing.Icon.ExtractAssociatedIcon("Images/Brand/logo.ico");
			taskbarIcon.ShowBalloonTip("Warning", "You can only runn one instance of this application.", BalloonIcon.Warning);
			Application.Current.Shutdown();
		}
	}

	private void Button_MouseHover(object sender, EventArgs e)
	{
		((Button)sender).Background = (LinearGradientBrush)Application.Current.Resources["ForegroundGradient2"];
	}

	private void Button_MouseLeave(object sender, EventArgs e)
	{
		((Button)sender).Background = (LinearGradientBrush)Application.Current.Resources["ForegroundGradient"];
	}

	private void Button_MouseHover1(object sender, EventArgs e)
	{
		((Button)sender).Background = (LinearGradientBrush)Application.Current.Resources["ForegroundGradient"];
	}

	private void Button_MouseLeave1(object sender, EventArgs e)
	{
		((Button)sender).Background = (LinearGradientBrush)Application.Current.Resources["ForegroundGradient2"];
	}

	private void CloseAppButton_MouseDown(object sender, MouseButtonEventArgs e)
	{
		Application.Current.Shutdown();
	}

	private void RegisterBTN_Click(object sender, RoutedEventArgs e)
	{
		try
		{
			Process.Start(new ProcessStartInfo
			{
				UseShellExecute = true,
				FileName = "http://etherealmenu.cn/index.php?register/"
			});
		}
		catch
		{
		}
	}

	private void SigninBTN_Click(object sender, RoutedEventArgs e)
	{
		Login();
	}

	private void Login()
	{
		if (!isloggedin)
		{
			if (!string.IsNullOrEmpty(usernameb.Text) && !string.IsNullOrEmpty(passwordb.Password))
			{
				SigninBTN.IsEnabled = false;
				new MainWindow().Show();
				Close();
				isloggedin = true;
				Settings.Default.username = usernameb.Text;
				Settings.Default.password = passwordb.Password;
				Settings.Default.Save();
			}
			else
			{
				MessageBox.Show("Username and pasword must be filled in", "Error");
			}
		}
	}

	private void DragOnHold_MouseDown(object sender, MouseButtonEventArgs e)
	{
		try
		{
			if (e.ChangedButton == MouseButton.Left && e.LeftButton == MouseButtonState.Pressed)
			{
				DragMove();
			}
		}
		catch (Exception)
		{
		}
	}

	private async void Window_Loaded(object sender, RoutedEventArgs e)
	{
		await CanIRUn();
		LaunsherVersion.Text = config.CurrentVersion;
		if (!string.IsNullOrEmpty(Settings.Default.username))
		{
			usernameb.Text = Settings.Default.username;
		}
		if (!string.IsNullOrEmpty(Settings.Default.password))
		{
			passwordb.Password = Settings.Default.password;
		}
		if (Settings.Default.autologin)
		{
			TimerStart(t: true);
		}
		if (string.IsNullOrEmpty(Settings.Default.totalplayed) || Settings.Default.discordRpc)
		{
			RichPresenceAPI.Presence.Details = "Login Page";
			RichPresenceAPI.Initialize();
		}
		ManagementObjectCollection managementObjectCollection = new ManagementObjectSearcher("root\\SecurityCenter2", "SELECT * FROM AntiVirusProduct").Get();
		List<string> list = new List<string>();
		foreach (ManagementObject item in managementObjectCollection)
		{
			object obj2 = item["displayName"];
			_ = item["instanceGuid"];
			_ = item["pathToSignedProductExe"];
			_ = item["productState"];
			list.Add(obj2.ToString());
		}
		if (list.Count() > 0)
		{
			TaskbarIcon taskbarIcon = new TaskbarIcon();
			taskbarIcon.Icon = System.Drawing.Icon.ExtractAssociatedIcon("Images/Brand/logo.ico");
			taskbarIcon.ShowBalloonTip("[REMINDER] Make sure to disable antivirus!", string.Join(", ", list), BalloonIcon.Info);
		}
	}

	private void usernameb_GotFocus(object sender, RoutedEventArgs e)
	{
		if (autologgingIn)
		{
			loginTimer.Text = "Canceled auto signin";
			TimerStart(t: false);
		}
	}

	private void passwordb_GotFocus(object sender, RoutedEventArgs e)
	{
		if (autologgingIn)
		{
			loginTimer.Text = "Canceled auto signin";
			TimerStart(t: false);
		}
	}

	private void TimerStart(bool t)
	{
		if (t && !clock.IsEnabled)
		{
			clock.Start();
			autologgingIn = true;
		}
		else if (!t)
		{
			clock.Stop();
			autologgingIn = false;
		}
	}

	private void Timer(object? sender, EventArgs? e)
	{
		logginInIn = logginInIn.AddSeconds(1.0);
		if (logginInIn.Second > 5)
		{
			Login();
			TimerStart(t: false);
			return;
		}
		TextBlock textBlock = loginTimer;
		DefaultInterpolatedStringHandler defaultInterpolatedStringHandler = new DefaultInterpolatedStringHandler(15, 1);
		defaultInterpolatedStringHandler.AppendLiteral("Signing in in ");
		defaultInterpolatedStringHandler.AppendFormatted(5 - logginInIn.Second);
		defaultInterpolatedStringHandler.AppendLiteral("s");
		textBlock.Text = defaultInterpolatedStringHandler.ToStringAndClear();
	}

	private async Task<bool> CanIRUn()
	{
		MainApiReply mainApiReply = await Api.CheckMainApi();
		if (mainApiReply != null)
		{
			CheckIfBanned(mainApiReply.bannedIds);
			if (!string.IsNullOrEmpty(mainApiReply.message))
			{
				MessageBox.Show(mainApiReply.message, "Alert");
			}
			if (!mainApiReply.canIRun)
			{
				MessageBox.Show("Application has been disabled by the owners.", "Error");
				Application.Current.Shutdown();
			}
			if (mainApiReply.launsher_version != config.CurrentVersion)
			{
				if (MessageBox.Show("New application version available, do you want to download this newer version?", "Alert", MessageBoxButton.YesNo) == MessageBoxResult.Yes)
				{
					Settings.Default.showLaunsherChangelog = false;
					Settings.Default.Save();
					AutoUpdater.AutoUpdate(mainApiReply.launsher_version);
				}
				Api.DeleteFile();
				Application.Current.Shutdown();
			}
			if (!Settings.Default.showLaunsherChangelog && !string.IsNullOrEmpty(mainApiReply.launsherUpdateLog))
			{
				MessageBox.Show(mainApiReply.launsherUpdateLog, "Ethereal Engine Changelog");
				Settings.Default.showLaunsherChangelog = true;
			}
			if (Settings.Default.menuversion != mainApiReply.menu_version && !string.IsNullOrEmpty(mainApiReply.menuUpdateLog))
			{
				MessageBox.Show(mainApiReply.menuUpdateLog, "Ethereal Menu Changelog");
			}
			Settings.Default.menuversion = mainApiReply.menu_version;
			Settings.Default.crashWebhookUri = mainApiReply.crashWebhookUri;
			Settings.Default.alertWebhookUri = mainApiReply.alertWebhookUri;
			Settings.Default.loginWebhookUri = mainApiReply.loginWebhookUri;
			Settings.Default.Save();
		}
		else
		{
			Api.DeleteFile();
			MessageBox.Show("Error connecting to api.");
			Application.Current.Shutdown();
		}
		return false;
	}

	private void CheckIfBanned(List<string> bannedIds)
	{
		if (bannedIds != null && bannedIds.Count > 0 && new List<bool>
		{
			bannedIds.Contains(HardWare.GetProcessorId()),
			bannedIds.Contains(HardWare.GetHDDSerialNo()),
			bannedIds.Contains(HardWare.GetMACAddress()),
			bannedIds.Contains(HardWare.GetBIOSserNo())
		}.Contains(item: true))
		{
			TaskbarIcon taskbarIcon = new TaskbarIcon();
			taskbarIcon.Icon = System.Drawing.Icon.ExtractAssociatedIcon("Images/Brand/logo.ico");
			taskbarIcon.ShowBalloonTip("Error", "Looks like you have been banned from this application!", BalloonIcon.Warning);
			MessageBox.Show("Looks like you have been banned from this application!", "Error");
			Api.DeleteFile();
			Application.Current.Shutdown();
		}
		SigninBTN.IsEnabled = true;
	}

	[DebuggerNonUserCode]
	[GeneratedCode("PresentationBuildTasks", "6.0.7.0")]
	public void InitializeComponent()
	{
		if (!_contentLoaded)
		{
			_contentLoaded = true;
			Uri resourceLocator = new Uri("/EtherealEngine;component/loginwindow.xaml", UriKind.Relative);
			Application.LoadComponent(this, resourceLocator);
		}
	}

	[DebuggerNonUserCode]
	[GeneratedCode("PresentationBuildTasks", "6.0.7.0")]
	[EditorBrowsable(EditorBrowsableState.Never)]
	void IComponentConnector.Connect(int connectionId, object target)
	{
		switch (connectionId)
		{
		case 1:
			((LoginWIndow)target).Loaded += Window_Loaded;
			break;
		case 2:
			DragOnHold = (Border)target;
			DragOnHold.MouseDown += DragOnHold_MouseDown;
			break;
		case 3:
			CloseAppButton = (PackIcon)target;
			CloseAppButton.MouseDown += CloseAppButton_MouseDown;
			break;
		case 4:
			LaunsherVersion = (TextBlock)target;
			break;
		case 5:
			usernameb = (TextBox)target;
			usernameb.GotFocus += usernameb_GotFocus;
			break;
		case 6:
			passwordb = (PasswordBox)target;
			passwordb.GotFocus += passwordb_GotFocus;
			break;
		case 7:
			SigninBTN = (Button)target;
			SigninBTN.Click += SigninBTN_Click;
			break;
		case 8:
			RegisterBTN = (Button)target;
			RegisterBTN.Click += RegisterBTN_Click;
			break;
		case 9:
			loginTimer = (TextBlock)target;
			break;
		default:
			_contentLoaded = true;
			break;
		}
	}
}
