using System;
using System.CodeDom.Compiler;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.IO.Compression;
using System.Linq;
using System.Net;
using System.Reflection;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Markup;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Media.Imaging;
using System.Windows.Threading;
using EtherealEngine.CustomExceptions;
using EtherealEngine.Inject;
using EtherealEngine.Models;
using EtherealEngine.Services;
using Hardcodet.Wpf.TaskbarNotification;
using MaterialDesignThemes.Wpf;

namespace EtherealEngine;

public class MainWindow : Window, IComponentConnector
{
	private Gta gta = new Gta();

	private string[] MenuSettings;

	private Configuration config = new Configuration();

	private readonly DispatcherTimer checkTImer = new DispatcherTimer();

	private readonly DispatcherTimer clock = new DispatcherTimer();

	private readonly DispatcherTimer antiDebugTimer = new DispatcherTimer();

	private readonly DispatcherTimer onlineCheckTimer = new DispatcherTimer();

	private readonly DispatcherTimer statsInterval = new DispatcherTimer();

	private DiscordWebhooks webhooks = new DiscordWebhooks();

	private bool CanIStartinject;

	private bool GtaRunning;

	private bool injected;

	private bool alreadyAskedForGtaPath;

	private bool injecting;

	private bool allDownloaded;

	private bool startinggta;

	private string gtaPlatform;

	private DateTime totalPlayed;

	private DateTime playing;

	private DateTime startDate;

	internal BeginStoryboard LoaderSpin_BeginStoryboard;

	internal Border DragOnHold;

	internal PackIcon CloseAppButton;

	internal PackIcon MinimizeButton;

	internal PackIcon EthMenuSettings;

	internal PackIcon StatsButton;

	internal PackIcon SettingsButton;

	internal Grid ExtraSettings;

	internal PackIcon RPCButton;

	internal PackIcon AutoLoginButton;

	internal PackIcon AutoInjectButton;

	internal PackIcon ResetSettings;

	internal System.Windows.Controls.Image EpicImg;

	internal System.Windows.Controls.Image SteamImg;

	internal System.Windows.Controls.Image RGLImg;

	internal TextBlock LaunsherVersion;

	internal TextBlock totalOnline;

	internal TextBlock MenuVersionText;

	internal TextBlock GtaPlatformText;

	internal TextBlock playTimeText;

	internal Grid StatsOnHover;

	internal TextBlock Status;

	internal Button InjectButton;

	internal Grid LoginDisableGrid;

	internal PackIcon loadericon;

	internal TextBlock LoadingScreenText;

	internal Grid StatsInfoBox;

	internal TextBlock EngineUserText;

	internal TextBlock RockstarNameText;

	internal CheckBox RpcRStarName;

	internal TextBlock RockstarIDText;

	internal CheckBox RpcRStarId;

	internal TextBlock SessionStateText;

	internal CheckBox RpcSessionState;

	internal TextBlock AttacksBlockedText;

	internal CheckBox RpcCrashesBlocked;

	internal TextBlock AttackSentText;

	internal CheckBox RpcCrashedSent;

	internal TextBlock totalPlayedtext;

	private bool _contentLoaded;

	public MainWindow()
	{
		InitializeComponent();
		checkTImer.Tick += CHeckForGta;
		checkTImer.Interval = new TimeSpan(0, 0, 2);
		clock.Tick += Timer;
		clock.Interval = new TimeSpan(0, 0, 1);
		onlineCheckTimer.Tick += OnlinePlayers;
		onlineCheckTimer.Interval = new TimeSpan(0, 2, 0);
		onlineCheckTimer.Start();
		statsInterval.Tick += SetStats;
		statsInterval.Interval = new TimeSpan(0, 0, 5);
		InjectButton.MouseEnter += Button_MouseHover;
		InjectButton.MouseLeave += Button_MouseLeave;
		antiDebugTimer.Tick += AntiDBGTimer;
		antiDebugTimer.Interval = new TimeSpan(0, 0, 2);
		antiDebugTimer.Start();
		if (Process.GetProcessesByName(Path.GetFileNameWithoutExtension(Assembly.GetEntryAssembly()?.Location)).Count() > 1)
		{
			TaskbarIcon taskbarIcon = new TaskbarIcon();
			taskbarIcon.Icon = System.Drawing.Icon.ExtractAssociatedIcon("Images/Brand/logo.ico");
			taskbarIcon.ShowBalloonTip("Warning", "You can only runn one instance of this application.", BalloonIcon.Warning);
			Application.Current.Shutdown();
		}
	}

	private void Button_MouseHover(object sender, EventArgs e)
	{
		((Button)sender).Background = (LinearGradientBrush)Application.Current.Resources["ForegroundGradient2"];
	}

	private void Button_MouseLeave(object sender, EventArgs e)
	{
		((Button)sender).Background = (LinearGradientBrush)Application.Current.Resources["ForegroundGradient"];
	}

	private async void Window_Loaded(object sender, RoutedEventArgs e)
	{
		LaunsherVersion.Text = config.CurrentVersion;
		if (!string.IsNullOrEmpty(Settings.Default.totalplayed))
		{
			totalPlayed = DateTime.Parse(Settings.Default.totalplayed);
		}
		totalPlayedtext.Text = DateToTime(totalPlayed);
		SetLastSettings();
		SetRPC("INIT");
		MenuVersionText.Text = (string.IsNullOrEmpty(Settings.Default.menuversion) ? "0.0.0" : Settings.Default.menuversion);
		SetOnlinePlayerCount();
		DownloadMenuFiles();
		if (File.Exists("C:\\Ethereal\\Ethereal.log"))
		{
			await File.WriteAllTextAsync("C:\\Ethereal\\Ethereal.log", "");
		}
		if (Settings.Default.autoinject && !injected)
		{
			injectMenu();
		}
	}

	private void InjectButton_Click(object sender, RoutedEventArgs e)
	{
		if (injected)
		{
			Quit();
			CHeckForGtaTImer(t: false);
		}
		else
		{
			injectMenu();
		}
	}

	public async void injectMenu()
	{
		if (string.IsNullOrEmpty(gtaPlatform))
		{
			MessageBox.Show("Pls select your Gta5 game platforn in settings first!", "Warning");
			return;
		}
		startinggta = false;
		injecting = true;
		alreadyAskedForGtaPath = false;
		if (await CanIInject())
		{
			playing = default(DateTime);
			CHeckForGtaTImer(t: true);
			string text = await new Api().GetDllBytes();
			if (!string.IsNullOrEmpty(text))
			{
				StartInjection(text);
				return;
			}
			Api.DeleteFile();
			MessageBox.Show("Something went wrong injecting.");
		}
		else
		{
			Api.DeleteFile();
		}
	}

	public async Task<string> isInjected()
	{
		string result = string.Empty;
		bool keepScanning = true;
		int attempts = 0;
		try
		{
			FileStream stream = new FileStream("C:\\Ethereal\\Ethereal.log", FileMode.Open, FileAccess.Read, FileShare.ReadWrite);
			if (File.Exists("C:\\Ethereal\\Ethereal.log"))
			{
				using (StreamReader sr = new StreamReader(stream))
				{
					while (keepScanning)
					{
						string text = await sr.ReadToEndAsync();
						if (!string.IsNullOrEmpty(text))
						{
							if (text.Contains("Hooking enabled"))
							{
								result = "";
								keepScanning = false;
							}
							if (text.Contains("当前账户无权限") || text.Contains("密码不正确") || text.Contains("用户不存在"))
							{
								result = "Invalid Login.";
								keepScanning = false;
								DiscordWebhooks.SendError("Injection Attemp", "Login attemp with invalid auth");
							}
							if (text.Contains("HWID MISMATCH"))
							{
								result = "HWID Mismatch.";
								keepScanning = false;
							}
						}
						attempts++;
						if (attempts > 120)
						{
							result = "Menu took to long to launch (max load time 2min)";
							keepScanning = false;
							DiscordWebhooks.SendError("Injection Failed", "Looks like i had some issues injecting the menu, is everything online?");
						}
						await Task.Delay(1000);
					}
				}
				return result;
			}
			return result;
		}
		catch (Exception)
		{
			return result;
		}
	}

	public async void StartInjection(string path)
	{
		_ = 2;
		try
		{
			if (File.Exists("C:\\Ethereal\\Ethereal.log"))
			{
				await File.WriteAllTextAsync("C:\\Ethereal\\Ethereal.log", "");
			}
			DllInjectionResult Result = Injection.GetInstance.Inject("GTA5", path);
			string caption;
			string title;
			switch (Result)
			{
			case DllInjectionResult.Success:
				caption = string.Empty;
				title = string.Empty;
				break;
			case DllInjectionResult.DllNotFound:
				caption = "Error launshing menu!";
				title = "Error";
				break;
			case DllInjectionResult.ProcessNotFound:
				caption = "Unable to find GTA5 process!";
				title = "Error";
				break;
			default:
				caption = "Injection failed";
				title = "Error";
				break;
			}
			string text = await isInjected();
			if (!string.IsNullOrEmpty(text))
			{
				Result = DllInjectionResult.InjectionFailed;
				caption = text;
				title = "Error";
			}
			if (Result == DllInjectionResult.Success)
			{
				SetStatus("INJECTED", null);
				TimerStart(t: true);
				Console.WriteLine("Successfully Injected");
				await Task.Delay(3000);
				Gta.SwitchToGTA5();
			}
			else
			{
				TaskbarIcon taskbarIcon = new TaskbarIcon();
				taskbarIcon.Icon = System.Drawing.Icon.ExtractAssociatedIcon("Images/Brand/logo.ico");
				taskbarIcon.ShowBalloonTip(title, caption, BalloonIcon.Error);
				Quit(stopGTA: false);
				MessageBox.Show(caption, title);
			}
		}
		catch (Exception ex)
		{
			Api.DeleteFile();
			throw new MainExceptoin("StartInjection", ex.Message);
		}
	}

	private void QuitButton_Click(object sender, RoutedEventArgs e)
	{
		Api.DeleteFile();
		Application.Current.Shutdown();
	}

	private void CloseAppButton_MouseDown(object sender, MouseButtonEventArgs e)
	{
		Api.DeleteFile();
		Close();
	}

	private void MinimizeButton_MouseDown(object sender, MouseButtonEventArgs e)
	{
		base.WindowState = WindowState.Minimized;
	}

	private void DragOnHold_MouseDown(object sender, MouseButtonEventArgs e)
	{
		try
		{
			if (e.ChangedButton == MouseButton.Left && e.LeftButton == MouseButtonState.Pressed)
			{
				DragMove();
			}
		}
		catch (Exception)
		{
		}
	}

	private void Window_Closing(object sender, CancelEventArgs e)
	{
		Quit();
	}

	private void StartGTAButton_Click(object sender, RoutedEventArgs e)
	{
		gta.StartGTA();
	}

	public void Quit(bool stopGTA = true)
	{
		if (stopGTA)
		{
			foreach (Process item in from p in Process.GetProcesses()
				orderby p.ProcessName
				select p)
			{
				if (item.ProcessName.ToUpper().Contains("GTA"))
				{
					item.Kill();
				}
			}
		}
		injecting = false;
		Api.DeleteFile();
		CHeckForGtaTImer(t: false);
		TimerStart(t: false);
		SetStatus("DISABLED", null);
	}

	private void CHeckForGtaTImer(bool t)
	{
		if (t && !checkTImer.IsEnabled)
		{
			checkTImer.Start();
		}
		else if (!t)
		{
			checkTImer.Stop();
		}
	}

	private void CHeckForGta(object? sender, EventArgs? e)
	{
		if (Process.GetProcessesByName("GTA5").FirstOrDefault((Process p) => p.MainWindowHandle != IntPtr.Zero) == null)
		{
			SetStatus("DISABLED", null);
			TimerStart(t: false);
			try
			{
				Quit();
				Api.DeleteFile();
			}
			catch (Exception)
			{
			}
		}
	}

	private void SetStatus(string status, string? readyInTime)
	{
		switch (status)
		{
		case "INJECTED":
			Status.Foreground = System.Windows.Media.Brushes.Green;
			Status.Text = "Ready for combat";
			GtaRunning = true;
			InjectButton.IsEnabled = true;
			injected = true;
			InjectButton.Content = "Quit";
			SetRPC("READY");
			SetOnlinePlayerCount();
			StatsTimer(t: true);
			break;
		case "LAUNSHINGGTA":
			Status.Foreground = System.Windows.Media.Brushes.Orange;
			Status.Text = "Starting GTA5 ...";
			GtaRunning = true;
			InjectButton.IsEnabled = false;
			SetRPC("STARTINGGTA");
			break;
		case "DISABLED":
			Status.Foreground = System.Windows.Media.Brushes.Red;
			Status.Text = "Standby";
			InjectButton.IsEnabled = true;
			GtaRunning = false;
			injected = false;
			CanIStartinject = false;
			InjectButton.Content = "Start";
			SetOnlinePlayerCount();
			StatsTimer(t: false);
			SetRPC("INIT");
			Api.DeleteFile();
			break;
		case "PREPARING":
			Status.Foreground = System.Windows.Media.Brushes.Yellow;
			Status.Text = "Preparing for combat ...";
			InjectButton.IsEnabled = false;
			SetRPC("PREPARING");
			break;
		case "READYIN":
			Status.Foreground = System.Windows.Media.Brushes.AliceBlue;
			Status.Text = "Ethereal ready in " + readyInTime;
			InjectButton.IsEnabled = false;
			SetRPC("WAITING", resetTimer: false);
			break;
		case "PLAYINGGTA":
			break;
		}
	}

	private void SetRPC(string status, bool resetTimer = true, string statsString = "")
	{
		switch (status)
		{
		case "OFF":
			RichPresenceAPI.Disable();
			break;
		case "STATS":
			if (Settings.Default.discordRpc)
			{
				RichPresenceAPI.Presence.State = statsString;
				RichPresenceAPI.Update(setTIme: false);
			}
			break;
		case "INIT":
			if (Settings.Default.discordRpc)
			{
				RichPresenceAPI.Presence.State = "";
				RichPresenceAPI.Presence.Details = (injected ? "Ready for combat." : "StandBy.");
				RichPresenceAPI.Update(resetTimer);
			}
			break;
		case "PREPARING":
			if (Settings.Default.discordRpc)
			{
				RichPresenceAPI.Presence.Details = "Preparing for combat ...";
				RichPresenceAPI.Update(resetTimer);
			}
			break;
		case "STARTINGGTA":
			if (Settings.Default.discordRpc)
			{
				RichPresenceAPI.Presence.Details = "Starting GTA5 ...";
				RichPresenceAPI.Update(resetTimer);
			}
			break;
		case "READY":
			if (Settings.Default.discordRpc)
			{
				RichPresenceAPI.Presence.Details = "Ready for combat.";
				RichPresenceAPI.Update(resetTimer);
			}
			break;
		case "WAITING":
			if (Settings.Default.discordRpc)
			{
				RichPresenceAPI.Presence.Details = "Waiting for GTA5 ...";
				RichPresenceAPI.Update(resetTimer);
			}
			break;
		}
	}

	private async Task<bool> CanIInject()
	{
		_ = 1;
		try
		{
			while (!CanIStartinject && injecting && !injected)
			{
				if (allDownloaded)
				{
					Process process = Process.GetProcessesByName("GTA5").FirstOrDefault((Process p) => p.MainWindowHandle != IntPtr.Zero);
					if (process != null)
					{
						try
						{
							double num = Math.Floor(DateTime.Now.Subtract(process.StartTime).TotalSeconds);
							if (num > 60.0)
							{
								CanIStartinject = true;
								SetStatus("PREPARING", null);
								return true;
							}
							MainWindow mainWindow = this;
							DefaultInterpolatedStringHandler defaultInterpolatedStringHandler = new DefaultInterpolatedStringHandler(1, 1);
							defaultInterpolatedStringHandler.AppendFormatted(60.0 - num);
							defaultInterpolatedStringHandler.AppendLiteral("s");
							mainWindow.SetStatus("READYIN", defaultInterpolatedStringHandler.ToStringAndClear());
						}
						catch (Exception)
						{
							MessageBox.Show("Error calculating gta5 playing time, if this keeps happening start gta befor injecting", "Error");
							Quit();
						}
					}
					else if (!GtaRunning)
					{
						if (!string.IsNullOrEmpty(Settings.Default.gtapath) && File.Exists(Settings.Default.gtapath ?? "") && !startinggta)
						{
							startinggta = true;
							gta.StartGTA();
							startDate = DateTime.Now;
							SetStatus("LAUNSHINGGTA", null);
						}
						else if (!alreadyAskedForGtaPath)
						{
							alreadyAskedForGtaPath = true;
							Api.DeleteFile();
							await gta.SetGTA5Path();
						}
						else if (alreadyAskedForGtaPath)
						{
							Quit();
							return false;
						}
					}
				}
				await Task.Delay(1000);
			}
		}
		catch (Exception ex2)
		{
			MessageBox.Show(ex2.Message ?? "", "Error");
			Quit();
		}
		return CanIStartinject;
	}

	private void TimerStart(bool t)
	{
		if (t && !clock.IsEnabled)
		{
			clock.Start();
		}
		else if (!t)
		{
			clock.Stop();
			Settings.Default.totalplayed = totalPlayed.ToString();
			Settings.Default.Save();
		}
	}

	private void Timer(object? sender, EventArgs? e)
	{
		totalPlayed = totalPlayed.AddSeconds(1.0);
		playing = playing.AddSeconds(1.0);
		totalPlayedtext.Text = DateToTime(totalPlayed);
		playTimeText.Text = DateToTime(playing);
	}

	private string DateToTime(DateTime date)
	{
		int num = date.Year - 1;
		int num2 = date.Day - 1;
		int hour = date.Hour;
		int minute = date.Minute;
		int second = date.Second;
		StringBuilder stringBuilder = new StringBuilder();
		object value;
		if (num <= 0)
		{
			value = "";
		}
		else
		{
			DefaultInterpolatedStringHandler defaultInterpolatedStringHandler = new DefaultInterpolatedStringHandler(2, 1);
			defaultInterpolatedStringHandler.AppendFormatted(num2);
			defaultInterpolatedStringHandler.AppendLiteral("y ");
			value = defaultInterpolatedStringHandler.ToStringAndClear();
		}
		stringBuilder.Append((string?)value);
		object value2;
		if (num2 <= 0)
		{
			value2 = "";
		}
		else
		{
			DefaultInterpolatedStringHandler defaultInterpolatedStringHandler = new DefaultInterpolatedStringHandler(2, 1);
			defaultInterpolatedStringHandler.AppendFormatted(num2);
			defaultInterpolatedStringHandler.AppendLiteral("d ");
			value2 = defaultInterpolatedStringHandler.ToStringAndClear();
		}
		stringBuilder.Append((string?)value2);
		object value3;
		if (hour <= 0)
		{
			value3 = "";
		}
		else
		{
			DefaultInterpolatedStringHandler defaultInterpolatedStringHandler = new DefaultInterpolatedStringHandler(2, 1);
			defaultInterpolatedStringHandler.AppendFormatted(hour);
			defaultInterpolatedStringHandler.AppendLiteral("h ");
			value3 = defaultInterpolatedStringHandler.ToStringAndClear();
		}
		stringBuilder.Append((string?)value3);
		object value4;
		if (minute <= 0)
		{
			value4 = "";
		}
		else
		{
			DefaultInterpolatedStringHandler defaultInterpolatedStringHandler = new DefaultInterpolatedStringHandler(2, 1);
			defaultInterpolatedStringHandler.AppendFormatted(minute);
			defaultInterpolatedStringHandler.AppendLiteral("m ");
			value4 = defaultInterpolatedStringHandler.ToStringAndClear();
		}
		stringBuilder.Append((string?)value4);
		object value5;
		if (second <= 0)
		{
			value5 = "";
		}
		else
		{
			DefaultInterpolatedStringHandler defaultInterpolatedStringHandler = new DefaultInterpolatedStringHandler(2, 1);
			defaultInterpolatedStringHandler.AppendFormatted(second);
			defaultInterpolatedStringHandler.AppendLiteral("s ");
			value5 = defaultInterpolatedStringHandler.ToStringAndClear();
		}
		stringBuilder.Append((string?)value5);
		return stringBuilder.ToString();
	}

	private string DateToTime1(DateTime d)
	{
		DefaultInterpolatedStringHandler defaultInterpolatedStringHandler = new DefaultInterpolatedStringHandler(8, 4);
		string value;
		if (d.Year >= 10)
		{
			value = d.Year.ToString();
		}
		else
		{
			DefaultInterpolatedStringHandler defaultInterpolatedStringHandler2 = new DefaultInterpolatedStringHandler(1, 1);
			defaultInterpolatedStringHandler2.AppendLiteral("0");
			defaultInterpolatedStringHandler2.AppendFormatted(d.Year);
			value = defaultInterpolatedStringHandler2.ToStringAndClear();
		}
		defaultInterpolatedStringHandler.AppendFormatted(value);
		defaultInterpolatedStringHandler.AppendLiteral(" : ");
		string value2;
		if (d.Hour >= 10)
		{
			value2 = d.Hour.ToString();
		}
		else
		{
			DefaultInterpolatedStringHandler defaultInterpolatedStringHandler2 = new DefaultInterpolatedStringHandler(1, 1);
			defaultInterpolatedStringHandler2.AppendLiteral("0");
			defaultInterpolatedStringHandler2.AppendFormatted(d.Hour);
			value2 = defaultInterpolatedStringHandler2.ToStringAndClear();
		}
		defaultInterpolatedStringHandler.AppendFormatted(value2);
		defaultInterpolatedStringHandler.AppendLiteral(" : ");
		string value3;
		if (d.Minute >= 10)
		{
			value3 = d.Minute.ToString();
		}
		else
		{
			DefaultInterpolatedStringHandler defaultInterpolatedStringHandler2 = new DefaultInterpolatedStringHandler(1, 1);
			defaultInterpolatedStringHandler2.AppendLiteral("0");
			defaultInterpolatedStringHandler2.AppendFormatted(d.Minute);
			value3 = defaultInterpolatedStringHandler2.ToStringAndClear();
		}
		defaultInterpolatedStringHandler.AppendFormatted(value3);
		defaultInterpolatedStringHandler.AppendLiteral(" :");
		string value4;
		if (d.Second >= 10)
		{
			value4 = d.Second.ToString();
		}
		else
		{
			DefaultInterpolatedStringHandler defaultInterpolatedStringHandler2 = new DefaultInterpolatedStringHandler(1, 1);
			defaultInterpolatedStringHandler2.AppendLiteral("0");
			defaultInterpolatedStringHandler2.AppendFormatted(d.Second);
			value4 = defaultInterpolatedStringHandler2.ToStringAndClear();
		}
		defaultInterpolatedStringHandler.AppendFormatted(value4);
		return defaultInterpolatedStringHandler.ToStringAndClear();
	}

	private void SettingsButton_MouseDown(object sender, MouseButtonEventArgs e)
	{
		if (ExtraSettings.Visibility == Visibility.Collapsed)
		{
			ExtraSettings.Visibility = Visibility.Visible;
			SettingsButton.Foreground = (SolidColorBrush)Application.Current.Resources["GreyToolBarIconColorEnabled"];
		}
		else
		{
			ExtraSettings.Visibility = Visibility.Collapsed;
			SettingsButton.Foreground = (SolidColorBrush)Application.Current.Resources["GreyToolBarIconColor"];
		}
	}

	private void RPCButton_MouseDown(object sender, MouseButtonEventArgs e)
	{
		if (Settings.Default.discordRpc)
		{
			SetSetting("rpc", enableorDisable: false, saveSettings: true);
		}
		else
		{
			SetSetting("rpc", enableorDisable: true, saveSettings: true);
		}
	}

	private void AutoLoginButton_MouseDown(object sender, MouseButtonEventArgs e)
	{
		if (Settings.Default.autologin)
		{
			SetSetting("login", enableorDisable: false, saveSettings: true);
		}
		else
		{
			SetSetting("login", enableorDisable: true, saveSettings: true);
		}
	}

	private void AutoInjectButton_MouseDown(object sender, MouseButtonEventArgs e)
	{
		if (Settings.Default.autoinject)
		{
			SetSetting("inject", enableorDisable: false, saveSettings: true);
		}
		else
		{
			SetSetting("inject", enableorDisable: true, saveSettings: true);
		}
	}

	private void SetLastSettings()
	{
		if (!Settings.Default.discordRpc)
		{
			SetSetting("RPC", enableorDisable: false);
		}
		else
		{
			SetSetting("RPC", enableorDisable: true);
		}
		if (!Settings.Default.autologin)
		{
			SetSetting("LOGIN", enableorDisable: false);
		}
		else
		{
			SetSetting("LOGIN", enableorDisable: true);
		}
		if (!Settings.Default.autoinject)
		{
			SetSetting("INJECT", enableorDisable: false);
		}
		else
		{
			SetSetting("INJECT", enableorDisable: true);
		}
		if (Settings.Default.gtaplatform == "rgl")
		{
			SetSetting("RGLPLATFORM", enableorDisable: true);
		}
		else if (Settings.Default.gtaplatform == "epic")
		{
			SetSetting("EPICPLATFORM", enableorDisable: true);
		}
		else if (Settings.Default.gtaplatform == "steam")
		{
			SetSetting("STEAMPLATFORM", enableorDisable: true);
		}
		EngineUserText.Text = ((!string.IsNullOrEmpty(Settings.Default.username)) ? Settings.Default.username : "Unkown");
		RpcRStarName.IsChecked = Settings.Default.RpcRStarName;
		RpcRStarId.IsChecked = Settings.Default.RpcRStarId;
		RpcSessionState.IsChecked = Settings.Default.RpcSessionState;
		RpcCrashesBlocked.IsChecked = Settings.Default.RpcCrashesBlocked;
		RpcCrashedSent.IsChecked = Settings.Default.RpcCrashedSent;
	}

	private void SetSetting(string setting, bool enableorDisable, bool saveSettings = false)
	{
		switch (setting.ToUpper())
		{
		case "LOGIN":
			if (enableorDisable)
			{
				AutoLoginButton.Foreground = (SolidColorBrush)Application.Current.Resources["GreyToolBarIconColorEnabled"];
				AutoLoginButton.ToolTip = "AutoSignIn Enabled";
				Settings.Default.autologin = true;
			}
			else
			{
				AutoLoginButton.Foreground = (SolidColorBrush)Application.Current.Resources["GreyToolBarIconColor"];
				AutoLoginButton.ToolTip = "AutoSignIn Disabled";
				Settings.Default.autologin = false;
			}
			break;
		case "INJECT":
			if (enableorDisable)
			{
				AutoInjectButton.Foreground = (SolidColorBrush)Application.Current.Resources["GreyToolBarIconColorEnabled"];
				AutoInjectButton.ToolTip = "AutoInjectButton Enabled";
				Settings.Default.autoinject = true;
			}
			else
			{
				AutoInjectButton.Foreground = (SolidColorBrush)Application.Current.Resources["GreyToolBarIconColor"];
				AutoInjectButton.ToolTip = "AutoInjectButton Disabled";
				Settings.Default.autoinject = false;
			}
			break;
		case "RPC":
			if (enableorDisable)
			{
				RPCButton.Foreground = (SolidColorBrush)Application.Current.Resources["GreyToolBarIconColorEnabled"];
				RPCButton.ToolTip = "DiscordRPC Enabled";
				Settings.Default.discordRpc = true;
				SetRPC("INIT");
			}
			else
			{
				RPCButton.Foreground = (SolidColorBrush)Application.Current.Resources["GreyToolBarIconColor"];
				RPCButton.ToolTip = "DiscordRPC Disabled";
				Settings.Default.discordRpc = false;
				SetRPC("OFF");
			}
			break;
		case "RGLPLATFORM":
			if (enableorDisable)
			{
				gtaPlatform = "rgl";
				GtaPlatformText.Text = "Rockstar Games";
				Settings.Default.gtaplatform = "rgl";
				if (File.Exists("C:\\Program Files\\Rockstar Games\\Grand Theft Auto V\\PlayGTAV.exe"))
				{
					Settings.Default.gtapath = "C:\\Program Files\\Rockstar Games\\Grand Theft Auto V\\PlayGTAV.exe";
				}
				else
				{
					Settings.Default.gtapath = "";
				}
				RGLImg.Source = new BitmapImage(new Uri("pack://application:,,,/Images/Launshers/rglOn.png", UriKind.RelativeOrAbsolute));
				SteamImg.Source = new BitmapImage(new Uri("pack://application:,,,/Images/Launshers/steamOff.png", UriKind.RelativeOrAbsolute));
				EpicImg.Source = new BitmapImage(new Uri("pack://application:,,,/Images/Launshers/epicOff.png", UriKind.RelativeOrAbsolute));
			}
			else
			{
				gtaPlatform = "";
				GtaPlatformText.Text = "Unknown";
				Settings.Default.gtaplatform = "";
				RGLImg.Source = new BitmapImage(new Uri("pack://application:,,,/Images/Launshers/rglOff.png", UriKind.RelativeOrAbsolute));
			}
			break;
		case "STEAMPLATFORM":
			if (enableorDisable)
			{
				gtaPlatform = "steam";
				GtaPlatformText.Text = "Steam";
				Settings.Default.gtaplatform = "steam";
				if (File.Exists("C:\\Program Files (x86)\\Steam\\Steam.exe"))
				{
					Settings.Default.gtapath = "C:\\Program Files (x86)\\Steam\\Steam.exe";
				}
				else
				{
					Settings.Default.gtapath = "";
				}
				SteamImg.Source = new BitmapImage(new Uri("pack://application:,,,/Images/Launshers/steamOn.png", UriKind.RelativeOrAbsolute));
				RGLImg.Source = new BitmapImage(new Uri("pack://application:,,,/Images/Launshers/rglOff.png", UriKind.RelativeOrAbsolute));
				EpicImg.Source = new BitmapImage(new Uri("pack://application:,,,/Images/Launshers/epicOff.png", UriKind.RelativeOrAbsolute));
			}
			else
			{
				gtaPlatform = "";
				GtaPlatformText.Text = "Unknown";
				Settings.Default.gtaplatform = "";
				RGLImg.Source = new BitmapImage(new Uri("pack://application:,,,/Images/Launshers/steamOff.png", UriKind.RelativeOrAbsolute));
			}
			break;
		case "EPICPLATFORM":
			if (enableorDisable)
			{
				gtaPlatform = "epic";
				GtaPlatformText.Text = "Epic Games";
				Settings.Default.gtaplatform = "epic";
				if (Environment.Is64BitOperatingSystem && File.Exists("C:\\Program Files (x86)\\Epic Games\\Launcher\\Portal\\Binaries\\Win64\\EpicGamesLauncher.exe"))
				{
					Settings.Default.gtapath = "C:\\Program Files (x86)\\Epic Games\\Launcher\\Portal\\Binaries\\Win64\\EpicGamesLauncher.exe";
				}
				else if (File.Exists("C:\\Program Files (x86)\\Epic Games\\Launcher\\Portal\\Binaries\\Win32\\EpicGamesLauncher.exe"))
				{
					Settings.Default.gtapath = "C:\\Program Files (x86)\\Epic Games\\Launcher\\Portal\\Binaries\\Win32\\EpicGamesLauncher.exe";
				}
				else
				{
					Settings.Default.gtapath = "";
				}
				EpicImg.Source = new BitmapImage(new Uri("pack://application:,,,/Images/Launshers/epicOn.png", UriKind.RelativeOrAbsolute));
				SteamImg.Source = new BitmapImage(new Uri("pack://application:,,,/Images/Launshers/steamOff.png", UriKind.RelativeOrAbsolute));
				RGLImg.Source = new BitmapImage(new Uri("pack://application:,,,/Images/Launshers/rglOff.png", UriKind.RelativeOrAbsolute));
			}
			else
			{
				gtaPlatform = "";
				GtaPlatformText.Text = "Unknown";
				Settings.Default.gtaplatform = "";
				RGLImg.Source = new BitmapImage(new Uri("pack://application:,,,/Images/Launshers/epicOff.png", UriKind.RelativeOrAbsolute));
			}
			break;
		}
		if (saveSettings)
		{
			Settings.Default.Save();
		}
	}

	private void ResetSettings_MouseDown(object sender, MouseButtonEventArgs e)
	{
		gtaPlatform = "";
		GtaPlatformText.Text = "Unknown";
		Settings.Default.gtapath = "";
		Settings.Default.gtaplatform = "";
		Settings.Default.Save();
		EpicImg.Source = new BitmapImage(new Uri("pack://application:,,,/Images/Launshers/epicOff.png", UriKind.RelativeOrAbsolute));
		SteamImg.Source = new BitmapImage(new Uri("pack://application:,,,/Images/Launshers/steamOff.png", UriKind.RelativeOrAbsolute));
		RGLImg.Source = new BitmapImage(new Uri("pack://application:,,,/Images/Launshers/rglOff.png", UriKind.RelativeOrAbsolute));
		MessageBox.Show("Succesfully resetted gta5 exe path.");
	}

	private async void DownloadMenuFiles()
	{
		LoginDisableGrid.Visibility = Visibility.Visible;
		try
		{
			using WebClient client = new WebClient();
			if (Directory.Exists("C:\\Ethereal"))
			{
				if (File.Exists("C:\\Ethereal\\settings.json"))
				{
					MenuSettings = await File.ReadAllLinesAsync("C:\\Ethereal\\settings.json");
				}
				Directory.Delete("C:\\Ethereal", recursive: true);
			}
			Uri address = new Uri(config.menuApiUrl);
			client.DownloadFileAsync(address, "C:\\Ethereal.zip");
			client.DownloadFileCompleted += client_DownloadFileCompleted;
			client.DownloadProgressChanged += delegate(object s, DownloadProgressChangedEventArgs e)
			{
				TextBlock loadingScreenText = LoadingScreenText;
				DefaultInterpolatedStringHandler defaultInterpolatedStringHandler = new DefaultInterpolatedStringHandler(11, 1);
				defaultInterpolatedStringHandler.AppendLiteral("Preparing ");
				defaultInterpolatedStringHandler.AppendFormatted(e.ProgressPercentage);
				defaultInterpolatedStringHandler.AppendLiteral("%");
				loadingScreenText.Text = defaultInterpolatedStringHandler.ToStringAndClear();
			};
		}
		catch (Exception ex)
		{
			throw new MainExceptoin("DownloadMenuFiles", ex.Message);
		}
	}

	private async void client_DownloadFileCompleted(object sender, AsyncCompletedEventArgs e)
	{
		try
		{
			LoadingScreenText.Text = "Almost done...";
			ZipFile.ExtractToDirectory("C:\\Ethereal.zip", "C:\\");
			await Task.Delay(2000);
			if (File.Exists("C:\\Ethereal\\auth.ini"))
			{
				File.WriteAllText("C:\\Ethereal\\auth.ini", "[user]\nusername=" + Settings.Default.username + "\npassword=" + Settings.Default.password);
			}
			if (File.Exists("C:\\Ethereal\\settings.json") && MenuSettings != null && MenuSettings.Length != 0)
			{
				File.WriteAllLines("C:\\Ethereal\\settings.json", MenuSettings);
			}
			LoginDisableGrid.Visibility = Visibility.Collapsed;
			InjectButton.IsEnabled = true;
			allDownloaded = true;
			File.Delete("C:\\Ethereal.zip");
		}
		catch (Exception ex)
		{
			throw new MainExceptoin("client_DownloadFileCompleted", ex.Message);
		}
	}

	private void EthMenuSettings_MouseDown(object sender, MouseButtonEventArgs e)
	{
		SettingsPage settingsPage = new SettingsPage();
		settingsPage.Owner = this;
		settingsPage.ShowDialog();
	}

	private void AntiDBGTimer(object? sender, EventArgs? e)
	{
		try
		{
			List<bool> obj = new List<bool>
			{
				AntiDebug.CloseHandleAntiDebug(),
				AntiDebug.DebuggerIsAttached(),
				AntiDebug.IsDebuggerPresentCheck(),
				AntiDebug.NtQueryInformationProcessCheck_ProcessDebugFlags(),
				AntiDebug.NtQueryInformationProcessCheck_ProcessDebugPort(),
				AntiDebug.HardwareRegistersBreakpointsDetection()
			};
			List<string> list = new List<string>
			{
				AntiVirtualization.IsSandboxiePresent(),
				AntiVirtualization.IsComodoSandboxPresent(),
				AntiVirtualization.IsQihoo360SandboxPresent(),
				AntiVirtualization.IsCuckooSandboxPresent(),
				AntiVirtualization.IsEmulationPresent(),
				AntiVirtualization.IsWinePresent(),
				AntiVirtualization.CheckForKVM(),
				AntiVirtualization.CheckForHyperV(),
				AntiVirtualization.CheckForBlacklistedNames()
			};
			if (!obj.Contains(item: true) && !list.Contains("[Bad]"))
			{
				return;
			}
			try
			{
				TaskbarIcon taskbarIcon = new TaskbarIcon();
				taskbarIcon.Icon = System.Drawing.Icon.ExtractAssociatedIcon("Images/Brand/logo.ico");
				taskbarIcon.ShowBalloonTip("AntiDebuging", "Debuging detected!", BalloonIcon.Error);
				DiscordWebhooks.DebugReport();
				AntidebugTricks();
				AntiDllInjection.PatchLoadLibraryA();
				AntiDllInjection.PatchLoadLibraryW();
				AntiDllInjection.BinarySignatureMitigationAntiDllInjection();
				AntiVirtualization.CrashingSandboxie();
				Process[] processesByName = Process.GetProcessesByName(Process.GetCurrentProcess().ProcessName);
				for (int i = 0; i < processesByName.Length; i++)
				{
					processesByName[i].Kill();
				}
			}
			catch
			{
				TaskbarIcon taskbarIcon2 = new TaskbarIcon();
				taskbarIcon2.Icon = System.Drawing.Icon.ExtractAssociatedIcon("Images/Brand/logo.ico");
				taskbarIcon2.ShowBalloonTip("AntiDebuging", "Debuging detected!", BalloonIcon.Error);
				DiscordWebhooks.DebugReport();
				new MainWindow().Close();
				Process[] processesByName = Process.GetProcessesByName(Process.GetCurrentProcess().ProcessName);
				for (int i = 0; i < processesByName.Length; i++)
				{
					processesByName[i].Kill();
				}
				AntidebugTricks();
			}
		}
		catch (Exception ex)
		{
			throw new MainExceptoin("AntiDBGTimer", ex.Message);
		}
	}

	private void AntidebugTricks()
	{
		try
		{
			AntiDebug.HideThreadsAntiDebug();
			AntiDebug.DebugBreakAntiDebug();
			AntiDebug.CloseHandleAntiDebug();
			AntiDebug.PatchingDbgUiRemoteBreakin();
		}
		catch (Exception ex)
		{
			throw new MainExceptoin("AntidebugTricks", ex.Message);
		}
	}

	private async void OnlinePlayers(object? sender, EventArgs? e)
	{
		SetOnlinePlayerCount();
	}

	private async void SetOnlinePlayerCount()
	{
		try
		{
			OnlineUsersApiReply onlineUsersApiReply = await Api.CountUserApi(injected);
			if (onlineUsersApiReply != null && onlineUsersApiReply.succes)
			{
				totalOnline.Text = onlineUsersApiReply.onlineCount.ToString();
			}
		}
		catch (Exception)
		{
		}
	}

	private void RGLImg_MouseDown(object sender, MouseButtonEventArgs e)
	{
		if (gtaPlatform != "rgl")
		{
			SetSetting("RGLPLATFORM", enableorDisable: true, saveSettings: true);
		}
	}

	private void SteamImg_MouseDown(object sender, MouseButtonEventArgs e)
	{
		if (gtaPlatform != "steam")
		{
			SetSetting("STEAMPLATFORM", enableorDisable: true, saveSettings: true);
		}
	}

	private void EpicImg_MouseDown(object sender, MouseButtonEventArgs e)
	{
		if (gtaPlatform != "epic")
		{
			SetSetting("EPICPLATFORM", enableorDisable: true, saveSettings: true);
		}
	}

	private void StatsTimer(bool t)
	{
		if (t && !statsInterval.IsEnabled)
		{
			statsInterval.Start();
		}
		else if (!t)
		{
			statsInterval.Stop();
		}
	}

	private void SetStats(object? sender, EventArgs? e)
	{
		SetStats();
	}

	private void StatsButton_MouseDown(object sender, MouseButtonEventArgs e)
	{
		if (StatsInfoBox.Visibility == Visibility.Collapsed)
		{
			StatsInfoBox.Visibility = Visibility.Visible;
			StatsButton.Foreground = (SolidColorBrush)Application.Current.Resources["GreyToolBarIconColorEnabled"];
		}
		else
		{
			StatsInfoBox.Visibility = Visibility.Collapsed;
			StatsButton.Foreground = (SolidColorBrush)Application.Current.Resources["GreyToolBarIconColor"];
		}
	}

	private void RPCOption_Click(object sender, RoutedEventArgs e)
	{
		try
		{
			CheckBox checkBox = (CheckBox)sender;
			Settings.Default[checkBox.Name] = checkBox.IsChecked;
			Settings.Default.Save();
		}
		catch (Exception)
		{
		}
	}

	private void SetStats()
	{
		List<string> logStats = Logger.GetLogStats(this);
		if (logStats == null || logStats.Count <= 0)
		{
			return;
		}
		string text = logStats[0];
		string text2 = logStats[1];
		string text3 = logStats[2];
		string text4 = logStats[3];
		string text5 = logStats[4];
		AttacksBlockedText.Text = text;
		AttackSentText.Text = text2;
		RockstarNameText.Text = text4;
		RockstarIDText.Text = text5;
		SessionStateText.Text = text3 + "/32";
		Dictionary<int, string> rpcDispList = new Dictionary<int, string>();
		if (Settings.Default.RpcRStarName)
		{
			rpcDispList.Add(rpcDispList.Count, "R* Username: " + text4);
		}
		if (Settings.Default.RpcRStarId)
		{
			rpcDispList.Add(rpcDispList.Count, "R* Id: " + text5);
		}
		if (Settings.Default.RpcSessionState)
		{
			rpcDispList.Add(rpcDispList.Count, "Session State: " + text3 + "/32");
		}
		if (Settings.Default.RpcCrashesBlocked)
		{
			rpcDispList.Add(rpcDispList.Count, "Crashes Blocked: " + text);
		}
		if (Settings.Default.RpcCrashedSent)
		{
			rpcDispList.Add(rpcDispList.Count, "Crashes Sent: " + text2);
		}
		int chooseThis = 0;
		if (rpcDispList.Values.Count > 1)
		{
			foreach (string state in rpcDispList.Values)
			{
				int key = rpcDispList.FirstOrDefault<KeyValuePair<int, string>>((KeyValuePair<int, string> x) => x.Value == state)!.Key;
				if (RichPresenceAPI.Presence.State == null || state == RichPresenceAPI.Presence.State)
				{
					chooseThis = key + 1;
				}
			}
		}
		SetRPC("STATS", resetTimer: false, rpcDispList.FirstOrDefault<KeyValuePair<int, string>>((KeyValuePair<int, string> s) => s.Key == ((chooseThis < rpcDispList.Count) ? chooseThis : 0))!.Value);
	}

	[DebuggerNonUserCode]
	[GeneratedCode("PresentationBuildTasks", "6.0.7.0")]
	public void InitializeComponent()
	{
		if (!_contentLoaded)
		{
			_contentLoaded = true;
			Uri resourceLocator = new Uri("/EtherealEngine;component/mainwindow.xaml", UriKind.Relative);
			Application.LoadComponent(this, resourceLocator);
		}
	}

	[DebuggerNonUserCode]
	[GeneratedCode("PresentationBuildTasks", "6.0.7.0")]
	[EditorBrowsable(EditorBrowsableState.Never)]
	void IComponentConnector.Connect(int connectionId, object target)
	{
		switch (connectionId)
		{
		case 1:
			((MainWindow)target).Loaded += Window_Loaded;
			((MainWindow)target).Closing += Window_Closing;
			break;
		case 2:
			LoaderSpin_BeginStoryboard = (BeginStoryboard)target;
			break;
		case 3:
			DragOnHold = (Border)target;
			DragOnHold.MouseDown += DragOnHold_MouseDown;
			break;
		case 4:
			CloseAppButton = (PackIcon)target;
			CloseAppButton.MouseDown += CloseAppButton_MouseDown;
			break;
		case 5:
			MinimizeButton = (PackIcon)target;
			MinimizeButton.MouseDown += MinimizeButton_MouseDown;
			break;
		case 6:
			EthMenuSettings = (PackIcon)target;
			EthMenuSettings.MouseDown += EthMenuSettings_MouseDown;
			break;
		case 7:
			StatsButton = (PackIcon)target;
			StatsButton.MouseDown += StatsButton_MouseDown;
			break;
		case 8:
			SettingsButton = (PackIcon)target;
			SettingsButton.MouseDown += SettingsButton_MouseDown;
			break;
		case 9:
			ExtraSettings = (Grid)target;
			break;
		case 10:
			RPCButton = (PackIcon)target;
			RPCButton.MouseDown += RPCButton_MouseDown;
			break;
		case 11:
			AutoLoginButton = (PackIcon)target;
			AutoLoginButton.MouseDown += AutoLoginButton_MouseDown;
			break;
		case 12:
			AutoInjectButton = (PackIcon)target;
			AutoInjectButton.MouseDown += AutoInjectButton_MouseDown;
			break;
		case 13:
			ResetSettings = (PackIcon)target;
			ResetSettings.MouseDown += ResetSettings_MouseDown;
			break;
		case 14:
			EpicImg = (System.Windows.Controls.Image)target;
			EpicImg.MouseDown += EpicImg_MouseDown;
			break;
		case 15:
			SteamImg = (System.Windows.Controls.Image)target;
			SteamImg.MouseDown += SteamImg_MouseDown;
			break;
		case 16:
			RGLImg = (System.Windows.Controls.Image)target;
			RGLImg.MouseDown += RGLImg_MouseDown;
			break;
		case 17:
			LaunsherVersion = (TextBlock)target;
			break;
		case 18:
			totalOnline = (TextBlock)target;
			break;
		case 19:
			MenuVersionText = (TextBlock)target;
			break;
		case 20:
			GtaPlatformText = (TextBlock)target;
			break;
		case 21:
			playTimeText = (TextBlock)target;
			break;
		case 22:
			StatsOnHover = (Grid)target;
			break;
		case 23:
			Status = (TextBlock)target;
			break;
		case 24:
			InjectButton = (Button)target;
			InjectButton.Click += InjectButton_Click;
			break;
		case 25:
			LoginDisableGrid = (Grid)target;
			break;
		case 26:
			loadericon = (PackIcon)target;
			break;
		case 27:
			LoadingScreenText = (TextBlock)target;
			break;
		case 28:
			StatsInfoBox = (Grid)target;
			break;
		case 29:
			EngineUserText = (TextBlock)target;
			break;
		case 30:
			RockstarNameText = (TextBlock)target;
			break;
		case 31:
			RpcRStarName = (CheckBox)target;
			RpcRStarName.Click += RPCOption_Click;
			break;
		case 32:
			RockstarIDText = (TextBlock)target;
			break;
		case 33:
			RpcRStarId = (CheckBox)target;
			RpcRStarId.Click += RPCOption_Click;
			break;
		case 34:
			SessionStateText = (TextBlock)target;
			break;
		case 35:
			RpcSessionState = (CheckBox)target;
			RpcSessionState.Click += RPCOption_Click;
			break;
		case 36:
			AttacksBlockedText = (TextBlock)target;
			break;
		case 37:
			RpcCrashesBlocked = (CheckBox)target;
			RpcCrashesBlocked.Click += RPCOption_Click;
			break;
		case 38:
			AttackSentText = (TextBlock)target;
			break;
		case 39:
			RpcCrashedSent = (CheckBox)target;
			RpcCrashedSent.Click += RPCOption_Click;
			break;
		case 40:
			totalPlayedtext = (TextBlock)target;
			break;
		default:
			_contentLoaded = true;
			break;
		}
	}
}
